<template>
  <div id="app" ref="app">
    <div class="input-handlers">
      <h1 class="input-handler-title">ADDRESS LOCATOR</h1>
      Provincia
      <Typeahead
        v-model="selected"
        :disabled="disabled[0]"
        :locationIndex="0"
        @getDisplayText="handleProceed($event)"
      />

      Municipio
      <Typeahead
        v-model="selected"
        :disabled="disabled[1]"
        :locationIndex="1"
        :province="province"
        @getDisplayText="handleProceed($event)"
      />

      Barangay
      <Typeahead
        v-model="selected"
        :disabled="disabled[2]"
        :locationIndex="2"
        :province="province"
        :municipality="municipality"
        @getDisplayText="handleProceed($event)"
      />
      Dirección
      <DataList
        v-model="selected"
        :disabled="disabled[3]"
        :locationIndex="3"
        :province="province"
        :municipality="municipality"
        :barangay="barangay"
        @getPlaceId="handleProceed($event)"
      />
      <p class="address-text is-size-7">Press 'Enter' after input.</p>
      <SearchButton
        :placeId="placeId"
        :disabled="disabled[4]"
        @getMapUrl="handleMapUrl($event)"
      />
    </div>
    <iframe :src="src" class="google-map" ref="map" />
  </div>
</template>

<script>
import url from './url';
import Typeahead from './components/Typeahead';
import DataList from './components/DataList';
import SearchButton from './components/SearchButton';

export default {
  name: 'App',
  components: { Typeahead, SearchButton, DataList },
  data() {
    return {
      src: url,
      locationIndex: null,
      title: null,
      selected: null,
      disabled: [false, true, true, true, true],
      province: '',
      municipality: '',
      barangay: '',
      placeId: ''
    };
  },

  methods: {
    handleProceed(location) {
      console.log(location);
      if (location.index === 0) {
        this.province = location.name;
        this.disabled[1] = false;

        if (this.province.localeCompare(location.name) === 0) {
          this.disabled[2] = true;
          this.disabled[3] = true;
          this.disabled[4] = true;
        }
      } else if (location.index === 1) {
        this.municipality = location.name;
        this.disabled[2] = false;

        if (this.municipality.localeCompare(location.name) === 0) {
          this.disabled[3] = true;
          this.disabled[4] = true;
        }
      } else if (location.index === 2) {
        this.barangay = location.name;
        this.disabled[3] = false;

        if (this.barangay.localeCompare(location.name) === 0)
          this.disabled[4] = true;
      } else {
        console.log(location);
        this.placeId = location;
        this.disabled[4] = false;
      }
    },
    handleMapUrl(url) {
      this.src = url;
      this.$refs.map.style.width = '50rem';
      this.$refs.app.style.gap = '4rem';
    }
  }
};
</script>

<style lang="scss">
* {
  font-family: 'Open Sans', sans-serif;
  box-sizing: border-box;
  transition: all 0.3s;
}

#app {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
  align-items: center;
  padding: 2rem 4rem;
  min-height: 100vh;
  background-image: url('./assets/bg.jpg');
  background-position: center center;
  background-repeat: no-repeat;
  background-attachment: fixed;
  background-size: cover;
}
.input-handlers {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  gap: 1rem;
  padding: 2rem 4rem;
  border-radius: 0.25rem;
  background: rgba(7, 23, 46, 0.95);
  border: 2px solid rgb(175, 25, 88);
  color: white;
  height: 100%;
  max-width: 400px;
}
.input-handler-title {
  font-size: 2rem;
  font-weight: bold;
  letter-spacing: 4px;
  text-align: center;
}
.address-text {
  color: rgb(175, 25, 88);
}
.google-map {
  height: 34.2rem;
  transition: all 1s;
  width: 0;
  border-radius: 0.25rem;
}
</style>
